/*
 *	This is NOT stunningly portable, but works for pretty dumb non-ANSI
 *	compilers and is tight. Adjust the sizes to taste.
 *
 *	Illegal format strings will break it. Only the following simple
 *	printf() subset is supported:
 *
 *		%%	literal % sign
 *
 *		%c	char
 *		%d	signed decimal
 *		%i	signed decimal
 *		%o	octal
 *		%p/%P	pointer - same as %x/%X respectively
 *		%s	string
 *		%t	pointer to string
 *		%u	unsigned decimal
 *		%x/%X	hexadecimal with lower/upper case letters
 *
 *	All except %% can be followed by a width specifier 1 -> 31 only
 *	and the h/l length specifiers also work where appropriate.
 *
 *		Alan Cox.
 *
 *	MTK:	Sep 97 - Misc hacks to shrink generated code
 */

#include <arch/segment.h>
#include <linuxmt/mm.h>

/*
 *	Just to make it work for now
 */

extern void con_charout(char);

static void con_write(register char *buf, int len)
{
    register char *p;

#ifdef CONFIG_DCON_ANSI_PRINTK

    /* Colourizing */

    static char colour[8] = { 27, '[', '3', '0', ';', '4', '0', 'm' };

    if (++(colour[3]) == '8')
	colour[3] = '1';

    p = colour;
    do
	con_charout(*p);
    while (*p++ != 'm');

    /* END Colourizing */

#endif

    p = (char *) len;

    while (p--) {
	if (*buf == '\n')
	    con_charout('\r');
	con_charout(*buf++);
    }
}

/************************************************************************
 *
 *	Output a number
 */

char *hex_string = "0123456789ABCDEF";		/* Also used by devices. */
char *hex_lower  = "0123456789abcdef";

static void numout(char *ptr, int len, int width, int base, int useSign,
		   int Upper, int Zero)
{
    unsigned long int v;
    register char *bp;
    char buf[12];

    if (width > sizeof(buf))		/* Error-check width specified */
	width = sizeof(buf);

	v = (len == 2) ? *((unsigned short *) ptr) : *((unsigned long *) ptr);
    if (useSign) {
	if (len == 2)
	    v = ((long)(*((short *) ptr)));
	if ((long)v < 0)
	    v = (-(long)v);
	else
	    useSign = 0;
    }

    bp = buf + sizeof(buf);

    {
	register char *bp2;

	bp2 = Upper ? hex_string : hex_lower;
    do {
	    *--bp = *(bp2 + (v % base));	/* Store digit */
	} while ((v /= base));
    }

    if (useSign && !Zero)
	*--bp = '-';

    width -= buf - bp + sizeof(buf);
    while (--width >= 0)			/* Process width */
	if (Zero)
	    *--bp = '0';
	else
	    *--bp = ' ';

    if (useSign && Zero) {
	if (*bp != '0')
	    bp--;
	*bp = '-';
    }

    con_write(bp, buf + sizeof(buf) - bp);
}

void printk(register char *fmt,int a1)
{
    register char *p = (char *) &a1;
    int len, width, zero;
    char c, tmp, *cp;

    while ((c = *fmt++)) {
	if (c != '%')
	    con_write(fmt - 1, 1);
	else {
	    c = *fmt++;

	    if (c == '%') {
		con_write("%", 1);
		continue;
	    }

	    width = zero = 0;
	    if (c == '0')
		zero++;
	    while (c >= '0' && c <= '9') {
		width *= 10;
		width += c - '0';
		c = *fmt++;
	    }

	    len = 2;
	    if (c == 'h')
		c = *fmt++;
	    else if (c == 'l') {
		len = 4;
		c = *fmt++;
	    }

	    switch (c) {
	    case 'o':
		tmp = 8;
		goto NUMOUT;
	    case 'i':
		c = 'd';
	    case 'd':
	    case 'u':
		tmp = 10;
		goto NUMOUT;
	    case 'P':
	    case 'p':
		c += 'X' - 'P';
	    case 'X':
	    case 'x':
		tmp = 16;
	    NUMOUT:
		numout(p, len, width, tmp, (c == 'd'), (c == 'X'), zero);
		p += len;
		break;
	    case 's':
		cp = *((char **) p);
		p += sizeof(char *);
		while (*cp) {
		    con_write(cp++, 1);
		    width--;
		}
		while (--width >= 0)
		    con_write(" ", 1);
		break;
	    case 't':
		cp = *((char **) p);
		p += sizeof(char *);
		while ((tmp = (char) get_fs_byte(cp))) {
		    con_charout(tmp);
		    cp++;
		    width--;
		}
		while (--width >= 0)
		    con_write(" ", 1);
		break;
	    case 'c':
		while (--width >= 1)
		    con_write(" ", 1);
		con_write(p, 1);
		p += 2;
		break;
	    default:
		con_write( "?", 1);
		break;
	    }
	}
    }
}

void panic(char *error, int a1 /* VARARGS... */ )
{
    register int *bp = (int *) &error - 2, i = 0, j;

    printk("\npanic: ");
    printk(error, a1);
    printk("\napparent call stack:\n");
    printk("Line: Addr    Parameters\n");
    printk("~~~~: ~~~~    ~~~~~~~~~~\n");

    do {
	printk("%4u: %04P =>", i, bp[1]);
	bp = (int *) bp[0];
	for (j = 2; j <= 8; j++)
	    printk(" %04X", bp[j]);
	printk("\n");
    } while (++i < 9);

    /* Lock up with infinite loop */

    printk("\nSYSTEM LOCKED - Press CTRL-ALT-DEL to reboot: ");

    while (1)
	/* Do nothing */;
}

void kernel_restarted(void)
{
    panic("kernel restarted\n");
}

void redirect_main(void)
{
    pokeb(get_cs(), 0, 0xe9);
    pokew(get_cs(), 1, ((__u16) kernel_restarted) - 3);
}
